using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Web.Security;
using WebseitenMonitor.DataAccess;

namespace WebseitenMonitor.Admin
{
	/// <summary>
	/// Summary description for UserManagement_AddUser.
	/// </summary>
	public class UserManagement_AddUser : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.Button LogoutButton;
		protected System.Web.UI.WebControls.TextBox NameTextBox;
		protected System.Web.UI.WebControls.TextBox PasswdTextBox;
		protected System.Web.UI.WebControls.TextBox PasswdConfirmTextBox;
		protected System.Web.UI.WebControls.Button CreateButton;
		protected System.Web.UI.WebControls.Button CancelButton;
		protected System.Web.UI.WebControls.RequiredFieldValidator NameRequiredFieldValidator;
		protected System.Web.UI.WebControls.CustomValidator NameCustomValidator;
		protected System.Web.UI.WebControls.RequiredFieldValidator PasswdRequiredFieldValidator;
		protected System.Web.UI.WebControls.CustomValidator PasswdCustomValidator;
		protected System.Web.UI.WebControls.Label ErrorLabel;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			// Put user code to initialize the page here
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		protected void CreateButtonClicked(object sender, EventArgs args) 
		{
			if(PasswdTextBox.Text != PasswdConfirmTextBox.Text) 
			{
				ErrorLabel.Text = "Das eingegebene Passwort stimmt mit dessen Wiederholung nicht berein!";
				return;
			}
			string errorMsg;
			UsersMediator.WriteResult res = UsersMediator.CreateNewUser(NameTextBox.Text, PasswdTextBox.Text, (string)Session["NewUser_Role"], out errorMsg);
			if(res == UsersMediator.WriteResult.Ok) 
			{
				Session.Remove("NewUser_Role");
				Response.Redirect("./UserManagement_Main.aspx");
			} 
			else 
			{
				ErrorLabel.Text = errorMsg;
			}
		}

		protected void CancelButtonClicked(object sender, EventArgs args) 
		{
			if(Session["NewUser_Role"] != null)
				Session.Remove("NewUser_Role");
			this.Response.Redirect("./UserManagement_Main.aspx");
		}

		protected void ValidateName(object source, ServerValidateEventArgs args) 
		{
			if(args.Value == null || args.Value.Length <= 0) 
			{
				((CustomValidator)source).ErrorMessage = "Es muss ein Benutzername angegeben werden!";
				args.IsValid = false;
			} 
			else if(args.Value.Length > 15) 
			{
				((CustomValidator)source).ErrorMessage = "Der Benutzername darf maximal 15 Zeichen umfassen!";
				args.IsValid = false;
			}
		}

		protected void ValidatePasswd(object source, ServerValidateEventArgs args) 
		{
			if(args.Value == null || args.Value.Length <= 0) 
			{
				((CustomValidator)source).ErrorMessage = "Es muss ein Passwort angegeben werden!";
				args.IsValid = false;
			} 
			else if(args.Value.Length > 20) 
			{
				((CustomValidator)source).ErrorMessage = "Das Passwort darf maximal 20 Zeichen umfassen!";
				args.IsValid = false;
			}
			if(FormsAuthentication.HashPasswordForStoringInConfigFile(args.Value,"md5").Length > 50) 
			{
				((CustomValidator)source).ErrorMessage = "Das Passwort hat zu viele Zeichen!";
				args.IsValid = false;
			}
		}

		protected void LogoutClicked(object sender, EventArgs args) 
		{
			FormsAuthentication.SignOut();
			Session.Clear();
			this.Response.Redirect("../Login.aspx");
		}
	}
}
