using System;
using System.Collections;
using System.ComponentModel;
using System.Web;
using System.Web.SessionState;
using System.Security.Principal;
using System.Web.Security;
using WebseitenMonitor.Security;

namespace WebseitenMonitor 
{
	/// <summary>
	/// Summary description for Global.
	/// </summary>
	public class Global : System.Web.HttpApplication
	{
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.IContainer components = null;

		public Global()
		{
			InitializeComponent();
		}	
		
		protected void Application_Start(Object sender, EventArgs e)
		{

		}
 
		protected void Session_Start(Object sender, EventArgs e)
		{

		}

		protected void Application_BeginRequest(Object sender, EventArgs e)
		{

		}

		protected void Application_EndRequest(Object sender, EventArgs e)
		{

		}

		/// <summary>
		/// Assign roles to authenticated Users.
		/// Note: This method is called as handler of the AuthenticateRequest event of the HttpApplication-Object.
		///	      The event trigger is initiated by the Formsauthentication-HttpModule (see Http-Pipeline-architecture).
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		protected void Application_AuthenticateRequest(Object sender, EventArgs e)
		{
			HttpApplication app = (HttpApplication)sender;
			if(app.Request.IsAuthenticated && app.User.Identity is FormsIdentity) 
			{
				FormsIdentity identity = (FormsIdentity)app.User.Identity;
				
				// Note: OnLogin-Handler in Login.aspx.cs assigned a UserDataWrapper-core-string as username.
				UserDataWrapper udw = new UserDataWrapper(identity.Name);

				// Assign Roles encoded in the UserDataWrapper-core-string
				app.Context.User = new GenericPrincipal(identity, udw.Roles);
			}

		}

		protected void Application_Error(Object sender, EventArgs e)
		{

		}

		protected void Session_End(Object sender, EventArgs e)
		{

		}

		protected void Application_End(Object sender, EventArgs e)
		{

		}
			
		#region Web Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.components = new System.ComponentModel.Container();
		}
		#endregion
	}
}

