using System;

namespace WebseitenMonitor.User.Help
{
	/// <summary>
	/// 
	/// </summary>
	public class HelpTextConstants
	{
		// General
		public static string ChooseKindHelpHtmlText =
@"
Es stehen zwei verschiedene Arten von Beobachtungskan&auml;len zur Verf&uuml;gung.<br>
Variante 1 - Benutzerdefinierte Meldung aus Webseite extrahieren und beobachten:<br>
&nbsp;&nbsp;&nbsp;Bei dieser Art von Beobachtungskanal k&ouml;nnen Sie individuell selektierte<br>
&nbsp;&nbsp;&nbsp;Bereiche f&uuml;r eine Webseite definieren deren &Auml;derung beobachtet wird.<br>
Variante 2 - Webseite bis zu einer gewissen Tiefe auf &Auml;nderungen beobachten:<br>
&nbsp;&nbsp;&nbsp;Bei dieser Art von Beobachtungskanal k&ouml;nnen Sie eine individuelle Tiefe<br>
&nbsp;&nbsp;&nbsp;festlegen. Diese Tiefe bezieht sich auf die weiterf&uuml;hrenden Links der Seite.<br>
";
		public static string NameHelpHtmlText = @"Geben Sie einen beliebigen Namen f&uuml;r den Beobachtungskanal ein.";
		public static string UrlHelpHtmlText = @"Geben Sie den Http-Url der zu beobachtenden Basis-Html-Seite ein.";
		// ChangeObservation specific
		public static string DepthHelpHtmlText = 
@"
Geben Sie die Tiefe ein, bis zu welcher weiterf&uuml;hrende<br>
Links verfolgt werden sollen.<br>
Die Tiefe muss mindestens 0 sein, woraufhin nur die Basisseite<br>
selbst beobachtet wird.
";
		// UserDefinedMessageObservation specific
		public static string SearchPatternEnableHelpHtmlText = 
@"
Hiermit k&ouml;nnen Sie ein Suchmuster aktivieren.<br>
Dadurch knnen das aufgrund der Selektionsbeschreibung ergebende<br>
Selektionsergebnis durch einen beliebigen Regul&auml;ren Ausdruck<br>
weiter verfeinern werden. Au&szlig;erdem kann eine beliebige benutzerdefinierte<br>
Meldung aus den Werten f&uuml;r Capturing Groups des Regul&auml;ren Ausdrucks<br>
zusammen gestellt werden.
";
		public static string SearchPatternHelpHtmlText = 
@"
Das Suchmuster legt einen Regul&auml;ren Ausdruck fest welcher auf das<br>
Selektionsergebnis entsprechend der Selektionsbeschreibung angewandt<br>
wird.<br>
ber Capturing Groups knnen Teile des Ergebnisses der Anwendung des<br>
Regul&auml;ren Ausdruckes als Basis f&uuml;r das Zusammenstellen<br>
einer benutzerdefinierten Meldung verwendet werden. Den Aufbau Dieser<br>
legt dabei die Meldungsvorlage fest.<br>
<br>
Folgende M&ouml;glichkeiten stellen die Regul&auml;ren Ausdr&uuml;ke zur Verf&uuml;gung:<br>
&nbsp;&nbsp;&nbsp;Literale:<br>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Literale zielen auf direkte &Uuml;bereinstimmung.<br>
&nbsp;&nbsp;&nbsp;Character Classes:<br>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Character Classes zielen auf eine beliebige &Uuml;bereinstimmung in der Klasse.<br>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Negierte Character Classes hingegen werden durch ein ^ am Anfang gekennzeichnet.<br>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Beispiele:<br>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;[0-9]&nbsp;:&nbsp; 0,1,...,9<br>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;[A-Za-z_]&nbsp;:&nbsp;A,B,...,Z,a,b,...,z,_<br>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;[ab]&nbsp;:&nbsp;a,b<br>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;[^u]&nbsp;:&nbsp;Alle Zeichen au&szlig;er u<br>
&nbsp;&nbsp;&nbsp;Character Classes Kurzformen:<br>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;\d ist eine Abk&uuml;rzung f&uml;r [0-9]<br>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;\w ist eine Abk&uuml;rzung f&uuml;r [A-Za-z]<br>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;\s ist eine Abk&uuml;rzung f&uuml;r [&nbsp;\t]<br>
&nbsp;&nbsp;&nbsp;Punkt:<br>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;.&bsp;bringt eine &Uuml;bereinstimmung mit allen Zeichen au&szlig;er<br>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;einem Zeilenwechsel.<br>
&nbsp;&nbsp;&nbsp;Anker:<br>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;^&nbsp;...&nbsp;Zeilenanfangsanker<br>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;$&nbsp;...&nbsp;Zeilenendeanker<br>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;\A&nbsp;...&nbsp;Textanfangsanker<br>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;\Z&nbsp;...&nbsp;Textendeanker<br>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;\b&nbsp;...&nbsp;Wortgrenze<br>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;\B&nbsp;...&nbsp;Negierte Wortgrenze<br>
&nbsp;&nbsp;&nbsp;Alternative:<br>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Alternative Auswahl aus Regul&auml;ren Ausdr&uuml;cken.<br>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Z.B.: Get&brvbar;GetValue&brvbar;Set&brvbar;SetValue<br>
&nbsp;&nbsp;&nbsp;Wiederholungen:<br>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Entsprechende &quot;greedy&quot; Wiederholung des vorherigen Zeichens oder Klammerausdrucks.<br>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;?&nbsp;...&nbsp;0 oder 1 mal<br>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;*&nbsp;...&nbsp;0 oder beliebig mehrmal<br>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;+&nbsp;...&nbsp;1 oder beliebig mehrmal<br>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;{min,max}&nbsp;...&nbsp;min bis max mal<br>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;{n}&nbsp;...&nbsp;genau n mal<br>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Um eine entsprechende &quot;lazy&quot; Variante zu erreichen muss ein ? nachgestellt werden.<br>
&nbsp;&nbsp;&nbsp;CapturingGroups:<br>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Es werden unbenannte und benannte Capturing Groups unterst&uuml;tzt.<br>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Grunds&auml;tzlich erzeugt jede Klammerung eine umbenannte Capturing Group,<br>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;wobei diese mit 1 beginnend implizit von links nach rechts durchnummeriert werden.<br>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Diese unbenannten Capturing Groups k&ouml;nnen mit der Syntax \n wiederverwendet<br>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;werden (\1 setzt also z.B. den Wert der ersten Capturing Group ein).<br>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Um die implizite Interpretation einer Klammerung als Capturing Group zu verhindern<br>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;muss nach der &ouml;ffnenden Klammer ?: geschrieben werden.<br>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Benannte Capturing Groups werden in der Form (?<name>group) oder (?'name'group) angegeben.<br>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Diese benannten Capturing Groups k&ouml;nnen &uuml;ber die Form \k<name> oder \k'name' wiederverwendet werden.<br>
&nbsp;&nbsp;&nbsp;Lookahead und Lookbehind:<br>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Beispiele:<br>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;q(?=u)&nbsp;...&nbsp;Positiver Lookahead<br>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;q(?!u)&nbsp;...&nbsp;Negativer Lookahead<br>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(?&lt;=a)b&nbsp;...&nbsp;Positiver Lookbehind<br>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(?&lt;!a)b&nbsp;...&nbsp;Negativer Lookahead<br>
<br>
Beachte: Es handelt sich bei dieser Auflistung nur um einen &Uuml;berblick. Eine entsprechende<br>
Vertiefung kann beispielsweise auf http://www.regular-expression.info gefunden werden.
";
		public static string MessageTemplateHelpHtmlText = 
@"
&Uuml;ber die Meldungsvorlage kann eine beliebige benutzerdefinierte Meldung zusammengestellt werden.<br>
Dabei k&ouml;nnen die Werte der Capturing Groups des Suchmusters als Parameter verwendet werden.<br>
Unbenannte Capturing Groups k&ouml;nnen dabei &uuml;ber die Form $1,$2,... eingebunden werden.<br>
Benannte Capturing Groups hingegen &uuml;ber die Form: ${name}<br>
Einen speziellen Parameter stellt $0 dar, er beinhaltet den &Uuml;bereinstimmungstext des gesamten<br>
Regul&auml;ren Ausdrucks.
";
		public static string SelectedElementsPositionDescriptorHelpHtmlText =
@"
Die Selektionsbeschreibung ist ein propriet&auml;res Format zur Beschreibung von Selektionen<br>
in einer Html-Seite basierend auf deren hierarchischer Position im DOM-Baum.<br>
Diese Selektionsbeschreibung wird normalerweise &uuml;ber den graphischen Selektionsmodus<br>
beim Erzeugen eines neuen Beobachtungskanals automatisch generiert.<br>
Falls ein h&auml;ndischer Eingriff gew&uuml;nscht wir kann dieser nach folgender Syntax<br>
durchgef&uuml;hrt werden.<br>
Die Selektionsbeschreibung muss folgende syntaktische Struktur aufweisen:<br>
&nbsp;&nbsp;&nbsp;ElementsPositionDescriptor = &quot;-&quot; &brvbar; (id &quot;;&quot; depth &quot;;&quot; LayerDescriptor{depth} &quot;&gt;&quot;).<br>
&nbsp;&nbsp;&nbsp;LayerDescriptor = nodeName &quot;,&quot; SearchDirection &quot;,&quot; numSamePrevSib &quot;,&quot; numSameNextSib &quot;;&quot;.<br>
&nbsp;&nbsp;&nbsp;SearchDirection = &quot;r&quot; &brvbar; &quot;l&quot; &brvbar; &quot;b&quot;.<br>
wobei:<br>
&nbsp;&nbsp;&nbsp;ElementsPositionDescriptor = &quot;-&quot; .. Leere Selektionsbeschreibung welche gesamten Html-Body bezeichnet.<br>
&nbsp;&nbsp;&nbsp;id .. Stetig steigende nichtnegative id (je fr&uuml;her selektiert, desto niedriger).<br>
&nbsp;&nbsp;&nbsp;depth .. Tiefe des selktierten Elements im DOM-Baum mit Htmp-Body Knoten als Wurzel.<br>
&nbsp;&nbsp;&nbsp;nodeName .. Name des DOM-Knotenelements entsprechend dem DOM-Kontenattribut nodeName.<br>
&nbsp;&nbsp;&nbsp;searchDirection .. Suchrichtung nach welcher das Element entsprechend der Anzahl der gleichbenannten Zwillinge auf<br>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;gleicher Ebene gesucht werden soll.<br>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&quot;r&quot; .. rechts (Von niedriger indizierten gleichbenannten Zwillingen aufw&auml;rts).<br>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&quot;l&quot; .. links (Von h&ouml;her indizierten gleichbenannten Zwillingen abw&auml;rts).<br>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&quot;b&quot; .. beide.<br>
&nbsp;&nbsp;&nbsp;numSamePrevSib .. Anzahl der gleichbenannten vorhergehenden Zwillinge auf aktueller Ebene.<br>
&nbsp;&nbsp;&nbsp;numSameNextSib .. Anzahl der gleichbenannten nachfolgenden Zwillinge auf aktueller Ebene.
";
		public static string CreateNewUserDefinedMessageObservationGuiChooseHelpHtmlText =
@"
In diesem Modus k&ouml;nnen Sie die zu beobachtenden Elemente der Seite durch graphische Selektion festlegen.<br>
Potentielle Elemente werden dabei bei Hervorgehoben wenn Sie den Mauszeiger dar&uuml;ber bewegen. Durch<br>
einen Klick auf das hervorgehobene Element k&ouml;nnen Sie diese markieren. Durch Bet&auml;tigen der<br>
Return-Taste werden die markierten Elemente als Selektionsgrundlage &uuml;bermittelt.<br> 
";
		public static string CreateNewUserDefinedMessageObservationExpertChooseHelpHtmlText = 
@"
In diesem Modus k&ouml;nnen Sie alle Parameter des Beobachtungskanals textuell eingeben.
";
	}
}
