using System;
using System.Web.UI;
using System.Web.UI.WebControls;

namespace WebseitenMonitor.Ui.CustomControls
{
	public class Fold : ImageButton
	{
		public string Text 
		{
			get { return ViewState["Text"]==null?"":(string)ViewState["Text"]; }
			set { ViewState["Text"] = value; }
		}

		public string Icon 
		{
			get { return ViewState["Icon"]==null?"Solid":(string)ViewState["Icon"]; }
			set { ViewState["Icon"] = value; }
		}

		public Fold() : base() { Click += new ImageClickEventHandler(FoldClick); }

		void FoldClick(object sender, ImageClickEventArgs e) 
		{
			string s = Text;
			Text = AlternateText;
			AlternateText = s; // Alternate Text from ImageButton
			if(Icon == "Solid")
				Icon = "Hollow";
			else
				Icon = "Solid";
		}

		protected override void Render(HtmlTextWriter w) 
		{
			w.Write("<input type=\"image\" name=\"" + this.UniqueID + "\"");
			w.Write(" src=\"../img/" + this.Icon + "Left.gif\" border=\"0\" />");
			w.Write(this.Text);
			w.Write("<img src=\"../img/" + this.Icon + "Right.gif\" >");
		}
	}
}
