using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Web.Security;
using WebseitenMonitor.Security;

namespace WebseitenMonitor.User
{
	/// <summary>
	/// Summary description for Header.
	/// </summary>
	public class Header : System.Web.UI.Page
	{
		protected Button LogoutButton;
		protected Label UserNameLabel;
		protected bool LogOutClicked;

		private void Page_Load(object sender, System.EventArgs e)
		{
			// Put user code to initialize the page here
			this.LogOutClicked = false;
			this.UserNameLabel.Text = this.GetUserName();
		}
		
		protected void OnLogOut(object sender, EventArgs args) 
		{
			FormsAuthentication.SignOut();
			Session.Clear();
			this.LogOutClicked = true;
		}
		
		protected string GetUserName() 
		{
			UserDataWrapper tmp = new UserDataWrapper(User.Identity.Name);
			return tmp.Loginname;
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.Load += new System.EventHandler(this.Page_Load);
		}
		#endregion
	}
}
