using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using WebseitenMonitor.Ui.CustomControls;
using WebseitenMonitor.User.Help;
using WebseitenMonitor.DomainObjects.Behaviour;
using WebseitenMonitor.DataAccess;
using WebseitenMonitor.Ui;

namespace WebseitenMonitor.User
{
	/// <summary>
	/// Summary description for ObservationCreateWizard_MsgObsExpert.
	/// </summary>
	public class ObservationCreateWizard_MsgObsExpert : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.CheckBox SearchPatternEnabledCheckBox;
		protected System.Web.UI.WebControls.TextBox SearchPatternTextBox;
		protected System.Web.UI.WebControls.RequiredFieldValidator SearchPatternRequiredFieldValidator;
		protected System.Web.UI.WebControls.CustomValidator SearchPatternCustomValidator;
		protected System.Web.UI.WebControls.TextBox MessageTemplateTextBox;
		protected System.Web.UI.WebControls.RequiredFieldValidator MessageTemplateRequiredFieldValidator;
		protected System.Web.UI.WebControls.CustomValidator MessageTemplateCustomValidator;
		protected System.Web.UI.WebControls.TextBox SelectedElementsPositionDescriptorTextBox;
		protected System.Web.UI.WebControls.RequiredFieldValidator SelectedElementsPositionDescriptorRequiredFieldValidator;
		protected WebseitenMonitor.Ui.CustomControls.Fold SearchPatternEnableHelpFold;
		protected WebseitenMonitor.Ui.CustomControls.Fold SearchPatternHelpFold;
		protected WebseitenMonitor.Ui.CustomControls.Fold MessageTemplateHelpFold;
		protected WebseitenMonitor.Ui.CustomControls.Fold SelectedElementsPositionDescriptorHelpFold;
		protected System.Web.UI.WebControls.Button CancelButton;
		protected System.Web.UI.WebControls.Button BackButton;
		protected System.Web.UI.WebControls.Button CreateButton;
		protected System.Web.UI.WebControls.CustomValidator SelectedElementsPositionDescriptorCustomValidator;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			if(!this.IsPostBack) 
			{
				if(Session["CreateWizard_SearchPatternEnableChooseItem"] != null)
					this.SearchPatternEnabledCheckBox.Checked = (bool)Session["CreateWizard_SearchPatternEnableChooseItem"];
				else
					this.SearchPatternEnabledCheckBox.Checked = true;
				if(Session["CreateWizard_SearchPatternItem"] != null)
					this.SearchPatternTextBox.Text = (string)Session["CreateWizard_SearchPatternItem"];
				else
					this.SearchPatternTextBox.Text = "";
				if(Session["CreateWizard_MessageTemplateItem"] != null)
					this.MessageTemplateTextBox.Text = (string)Session["CreateWizard_MessageTemplateItem"];
				else
					this.MessageTemplateTextBox.Text = "";
				if(Session["CreateWizard_SelectedElementsPositionDescriptorItem"] != null)
					this.SelectedElementsPositionDescriptorTextBox.Text = (string)Session["CreateWizard_SelectedElementsPositionDescriptorItem"];
				else
					this.SelectedElementsPositionDescriptorTextBox.Text = "-";
				this.SearchPatternEnableHelpFold.AlternateText = HelpTextConstants.SearchPatternEnableHelpHtmlText;
				this.SearchPatternHelpFold.AlternateText = HelpTextConstants.SearchPatternHelpHtmlText;
				this.MessageTemplateHelpFold.AlternateText = HelpTextConstants.MessageTemplateHelpHtmlText;
				this.SelectedElementsPositionDescriptorHelpFold.AlternateText = HelpTextConstants.SelectedElementsPositionDescriptorHelpHtmlText;
			}
		}

		protected void SearchPatternEnableChanged(object sender, EventArgs args) 
		{
			if(this.SearchPatternEnabledCheckBox.Checked) 
			{
				this.SearchPatternTextBox.Enabled = true;
				this.MessageTemplateTextBox.Enabled = true;
				this.SearchPatternRequiredFieldValidator.Enabled = true;
				this.MessageTemplateRequiredFieldValidator.Enabled = true;
				this.SearchPatternCustomValidator.Enabled = true;
				this.MessageTemplateCustomValidator.Enabled = true;
				this.SearchPatternHelpFold.Visible = true;
				this.MessageTemplateHelpFold.Visible = true;
			} 
			else 
			{
				this.SearchPatternTextBox.Enabled = false;
				this.MessageTemplateTextBox.Enabled = false;
				this.SearchPatternRequiredFieldValidator.Enabled = false;
				this.MessageTemplateRequiredFieldValidator.Enabled = false;
				this.SearchPatternCustomValidator.Enabled = false;
				this.MessageTemplateCustomValidator.Enabled = false;
				this.SearchPatternHelpFold.Visible = false;
				this.MessageTemplateHelpFold.Visible = false;
			}
		}

		protected void ValidateSearchPattern(object source, ServerValidateEventArgs args) 
		{
			string errorMsg;
			if(!UserDefinedMessageObservation.CheckSearchPattern(args.Value, out errorMsg)) 
			{
				((CustomValidator)source).ErrorMessage = errorMsg;
				args.IsValid = false;
			}
		}

		protected void ValidateMessageTemplate(object source, ServerValidateEventArgs args) 
		{
			string errorMsg;
			if(!UserDefinedMessageObservation.CheckMessageTemplate(args.Value, out errorMsg)) 
			{
				((CustomValidator)source).ErrorMessage = errorMsg;
				args.IsValid = false;
			}
		}

		protected void ValidateSelectedElementsPositionDescriptor(object source, ServerValidateEventArgs args) 
		{
			string errorMsg;
			if(!UserDefinedMessageObservation.CheckSelectedElementsPositionDescriptor(args.Value, out errorMsg)) 
			{
				((CustomValidator)source).ErrorMessage = errorMsg;
				args.IsValid = false;
			}
		}

		protected void CancelButtonClicked(object sender, EventArgs args) 
		{
			Session.Remove("CreateWizard_KindItem");
			Session.Remove("CreateWizard_NameItem");
			Session.Remove("CreateWizard_UrlItem");
			if(Session["CreateWizard_DepthItem"] != null)
				Session.Remove("CreateWizard_DepthItem");
			if(Session["CreateWizard_MsgObsGuiCreateMode"] != null)
				Session.Remove("CreateWizard_MsgObsGuiCreateMode");
			if(Session["CreateWizard_SearchPatternEnableChooseItem"] != null)
				Session.Remove("CreateWizard_SearchPatternEnableChooseItem");
			if(Session["CreateWizard_SearchPatternItem"] != null)
				Session.Remove("CreateWizard_SearchPatternItem");
			if(Session["CreateWizard_MessageTemplateItem"] != null)
				Session.Remove("CreateWizard_MessageTemplateItem");
			if(Session["CreateWizard_SelectedElementsPositionDescriptorItem"] != null)
				Session.Remove("CreateWizard_SelectedElementsPositionDescriptorItem");
			this.Response.Redirect("./CategoryContent.aspx");
		}

		protected void BackButtonClicked(object sender, EventArgs args) 
		{
			Session["CreateWizard_SearchPatternEnableChooseItem"] = this.SearchPatternEnabledCheckBox.Checked;
			Session["CreateWizard_SearchPatternItem"] = this.SearchPatternTextBox.Text;
			Session["CreateWizard_MessageTemplateItem"] = this.MessageTemplateTextBox.Text;
			Session["CreateWizard_SelectedElementsPositionDescriptorItem"] = this.SelectedElementsPositionDescriptorTextBox.Text;
			this.Response.Redirect("./ObservationCreateWizard_MsgObsGeneral.aspx");
		}

		protected void CreateButtonClicked(object sender, EventArgs args) 
		{
			if(this.Page.IsValid) 
			{
				CategoryNavigationForest myForest = (CategoryNavigationForest)Session["UserForest"];
				int insertedObservationId;
				string errorMsg;
				UserDefinedMessageObservationMediator.WriteResult res = UserDefinedMessageObservationMediator.WriteInitUserDefinedMessageObservation(
					(string)Session["CreateWizard_NameItem"],
					(Uri)Session["CreateWizard_UrlItem"],
					myForest.SelectedCategoryId,
					this.SearchPatternEnabledCheckBox.Checked,
					this.SearchPatternTextBox.Text,
					this.MessageTemplateTextBox.Text,
					this.SelectedElementsPositionDescriptorTextBox.Text,
					out insertedObservationId,
					out errorMsg);
				// Remove Wizard specific SessionVariables
				Session.Remove("CreateWizard_KindItem");
				Session.Remove("CreateWizard_NameItem");
				Session.Remove("CreateWizard_UrlItem");
				if(Session["CreateWizard_DepthItem"] != null)
					Session.Remove("CreateWizard_DepthItem");
				if(Session["CreateWizard_MsgObsGuiCreateMode"] != null)
					Session.Remove("CreateWizard_MsgObsGuiCreateMode");
				if(Session["CreateWizard_SearchPatternEnableChooseItem"] != null)
					Session.Remove("CreateWizard_SearchPatternEnableChooseItem");
				if(Session["CreateWizard_SearchPatternItem"] != null)
					Session.Remove("CreateWizard_SearchPatternItem");
				if(Session["CreateWizard_MessageTemplateItem"] != null)
					Session.Remove("CreateWizard_MessageTemplateItem");
				if(Session["CreateWizard_SelectedElementsPositionDescriptorItem"] != null)
					Session.Remove("CreateWizard_SelectedElementsPositionDescriptorItem");
				if(res != UserDefinedMessageObservationMediator.WriteResult.Ok) 
				{
					Session["ErrorMessage"] = "Es ist ein Problem w&auml;hrend dem Datenbankzugriff aufgetreten!";
					Response.Redirect("./ErrorPage.aspx");
				}
				Session["CurrentUserDefinedMessageObservationDetailId"] = insertedObservationId;
				Response.Redirect("UserDefinedMessageObservationDetail.aspx");
			}
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion
	}
}
