using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using WebseitenMonitor.Ui.CustomControls;
using WebseitenMonitor.User.Help;

namespace WebseitenMonitor.User
{
	/// <summary>
	/// Summary description for ObservationCreateWizard_MsgObsGeneral.
	/// </summary>
	public class ObservationCreateWizard_MsgObsGeneral : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.RadioButton MsgGuiDrivenChoosenRadioButton;
		protected WebseitenMonitor.Ui.CustomControls.Fold GuiDrivenChooseHelpFold;
		protected WebseitenMonitor.Ui.CustomControls.Fold ExpertModeChooseHelpFold;
		protected System.Web.UI.WebControls.Button CancelButton;
		protected System.Web.UI.WebControls.Button BackButton;
		protected System.Web.UI.WebControls.Button ForwardButton;
		protected System.Web.UI.WebControls.RadioButton MsgExpertChoosenRadioButton;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			if(!this.IsPostBack) 
			{
				// initialize Controlls
				if(Session["CreateWizard_MsgObsGuiCreateMode"] != null) 
				{
					this.MsgGuiDrivenChoosenRadioButton.Checked = (bool)Session["CreateWizard_MsgObsGuiCreateMode"]?true:false;
					this.MsgExpertChoosenRadioButton.Checked = !this.MsgGuiDrivenChoosenRadioButton.Checked;
				} 
				else 
				{
					this.MsgGuiDrivenChoosenRadioButton.Checked = true;
					this.MsgExpertChoosenRadioButton.Checked = false;
				}
				this.GuiDrivenChooseHelpFold.AlternateText = HelpTextConstants.CreateNewUserDefinedMessageObservationGuiChooseHelpHtmlText;
				this.ExpertModeChooseHelpFold.AlternateText = HelpTextConstants.CreateNewUserDefinedMessageObservationExpertChooseHelpHtmlText;
			}
		}

		protected void CancelButtonClicked(object sender, EventArgs args) 
		{
			if(Session["CreateWizard_DepthItem"] != null)
				Session.Remove("CreateWizard_DepthItem");
			if(Session["CreateWizard_MsgObsGuiCreateMode"] != null)
				Session.Remove("CreateWizard_MsgObsGuiCreateMode");
			if(Session["CreateWizard_KindItem"] != null)
				Session.Remove("CreateWizard_KindItem");
			if(Session["CreateWizard_NameItem"] != null)
				Session.Remove("CreateWizard_NameItem");
			if(Session["CreateWizard_UrlItem"] != null)
				Session.Remove("CreateWizard_UrlItem");
			if(Session["CreateWizard_DepthItem"] != null)
				Session.Remove("CreateWizard_DepthItem");
			if(Session["CreateWizard_MsgObsGuiCreateMode"] != null)
				Session.Remove("CreateWizard_MsgObsGuiCreateMode");
			if(Session["CreateWizard_SearchPatternEnableChooseItem"] != null)
				Session.Remove("CreateWizard_SearchPatternEnableChooseItem");
			if(Session["CreateWizard_SearchPatternItem"] != null)
				Session.Remove("CreateWizard_SearchPatternItem");
			if(Session["CreateWizard_MessageTemplateItem"] != null)
				Session.Remove("CreateWizard_MessageTemplateItem");
			if(Session["CreateWizard_SelectedElementsPositionDescriptorItem"] != null)
				Session.Remove("CreateWizard_SelectedElementsPositionDescriptorItem");

			this.Response.Redirect("./CategoryContent.aspx");
		}

		protected void BackButtonClicked(object sender, EventArgs args) 
		{
			Session["CreateWizard_MsgObsGuiCreateMode"] = this.MsgGuiDrivenChoosenRadioButton.Checked?true:false;
			this.Response.Redirect("./ObservationCreateWizard_General.aspx");
		}

		protected void ForwardButtonClicked(object sender, EventArgs args) 
		{
			
			if(this.MsgGuiDrivenChoosenRadioButton.Checked) 
			{
				Session["NewObservationName"] = (string)Session["CreateWizard_NameItem"];
				Session["SelectedPageUrl"] = ((Uri)Session["CreateWizard_UrlItem"]).ToString(); // Link to userselection
				if(Session["CreateWizard_KindItem"] != null)
					Session.Remove("CreateWizard_KindItem");
				if(Session["CreateWizard_NameItem"] != null)
					Session.Remove("CreateWizard_NameItem");
				if(Session["CreateWizard_UrlItem"] != null)
					Session.Remove("CreateWizard_UrlItem");
				if(Session["CreateWizard_DepthItem"] != null)
					Session.Remove("CreateWizard_DepthItem");
				if(Session["CreateWizard_MsgObsGuiCreateMode"] != null)
					Session.Remove("CreateWizard_MsgObsGuiCreateMode");
				if(Session["CreateWizard_SearchPatternEnableChooseItem"] != null)
					Session.Remove("CreateWizard_SearchPatternEnableChooseItem");
				if(Session["CreateWizard_SearchPatternItem"] != null)
					Session.Remove("CreateWizard_SearchPatternItem");
				if(Session["CreateWizard_MessageTemplateItem"] != null)
					Session.Remove("CreateWizard_MessageTemplateItem");
				if(Session["CreateWizard_SelectedElementsPositionDescriptorItem"] != null)
					Session.Remove("CreateWizard_SelectedElementsPositionDescriptorItem");
				Response.Redirect("./Select/EnhanceSelectedPage.aspx");
			}
			else 
			{
				Session["CreateWizard_MsgObsGuiCreateMode"] = this.MsgGuiDrivenChoosenRadioButton.Checked?true:false;
				this.Response.Redirect("./ObservationCreateWizard_MsgObsExpert.aspx");
			}
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion
	}
}
