var numElementsMarked; // num of already marked and possibly in the meantime demarked elements
var markedElementsArray; // array for the marked elements position-strings

// Registers the Event-Handlers
function initMyScript() {
  numElementsMarked = 0;
  markedElementsArray = new Array;

  var pArray=document.getElementsByTagName('BODY');
  var myElements = document.body.childNodes;
  document.onkeydown = mySubmitMarkedElements;
  for(var i=0; i<myElements.length; i++) {
    myElements[i].onmouseover = myMarkElementByColorInversion;
    myElements[i].onmouseout = myReverseMarkElementByColorInversion;
    myElements[i].onclick = myPermanentlyMarkElement;
  }
}

// Submits the string descriping the position of the marked (selected) elements.
// This is done over the Form named "markedElementsSubmitForm" with its hidden field named "selectionPath".
// The string descriping the position of the marked elements is build by concatenating the components of the global array named "markedElementsArray".
function mySubmitMarkedElements(e) {
  var i;
  var mySubmitString = "";
  for(i = 0; i< markedElementsArray.length; i++) {
    if(markedElementsArray[i] != null)
      mySubmitString = mySubmitString + markedElementsArray[i];
  }
  
  document.markedElementsSubmitForm.selectionPath.value=mySubmitString;
  document.markedElementsSubmitForm.submit();
  
  //alert(mySubmitString);
}

// Stores the position-string of the selected Element (initTarget) in the global array "markedElementsArray".
// The syntax of one position-string:
//     ElementPositionString = id ";" depth ";" LayerDescriptor{depth} ">".
//     LayerDescriptor = nodeName "," numSamePrevSib "," numSameNextSib "," elemCountRelToBody "," sameElemCountRelToFather "," sourceIndexRelToBody ";".
//   where:
//     id .. steady increasing non-negative integer identifier (the earlier selected the lower the id).
//     depth .. depth of selected element in DOM-Tree with Body-node as root-node.
//     nodeName .. corresponding to DOM-node-attribute nodeName.
//     numSamePrevSib .. number of same named previous siblings in current layer.
//     numSameNextSib .. number of same named following siblings in current layer.
//     elemCountRelToBody .. count-index of current-layer-element relative to the Body-node (nodes of type elementnode (typeid 1) count - body itself has index 0)
//     sameElemCountRelToFather .. count-index of current-layer-element relative to Father-node (only same named elementnodes count - father itself has index 0 whether same named or not)
//     sourceIndexRelToBody .. DOM-node-attribute sourceIndex relative to that of document.body (only available in MS Internet Explorer), if not defined sourceIndexRelToBody is -1. 
function storeRecursivePositionList(initTarget) {
	var currentElement = initTarget;
	var tmpNode = null;
	
	var names = new Array();
	var numSamePrevSibs = new Array();
	var numSameNextSibs = new Array();
	var elemCountRelToBodies = new Array();
	var sameElemCountRelToFathers = new Array();
	var sourceIndexRelToBodies = new Array();
	
	var i = 0;
	var tmpReturn;
	
	
	while(currentElement != null && currentElement != document.body) {
		// determine names
		names[i] = currentElement.nodeName.toLowerCase();
		// determine numSamePrevSibs of current-layer-node
		numSamePrevSibs[i] = 0;
		tmpNode = currentElement.previousSibling;
		while(tmpNode != null) {
			if(tmpNode.nodeName.toLowerCase().toString() == currentElement.nodeName.toLowerCase().toString())
				numSamePrevSibs[i] = numSamePrevSibs[i] + 1;
			tmpNode = tmpNode.previousSibling;
		}
		// determine numSameFollowSibs of current-layer-node
		numSameNextSibs[i] = 0;
		tmpNode = currentElement.nextSibling;
		while(tmpNode != null) {
			if(tmpNode.nodeName.toLowerCase() == currentElement.nodeName.toLowerCase())
				numSameNextSibs[i] = numSameNextSibs[i] + 1;
			tmpNode = tmpNode.nextSibling;
		}
		// determine sourceIndex if defined (MS Internet Explorer) otherwise -1
		if(typeof(currentElement.sourceIndex) == "undefined" || typeof(document.body.sourceIndex) == "undefined")
			sourceIndexRelToBodies[i] = -1;
		else
			sourceIndexRelToBodies[i] = currentElement.sourceIndex - document.body.sourceIndex;
		// determine pre-reverse-calculation of elemCountRelToBodies and final-calculation of sameElemCountRelToFather
		tmpReturn = myDetermineElemCountOfPrevSibsDecendentsOrSelfs(currentElement);
		elemCountRelToBodies[i] = tmpReturn[0] + 1;
		sameElemCountRelToFathers[i] = tmpReturn[1] + 1;
		
		// increase depth-index and traverse to one layer higher
		currentElement = currentElement.parentNode;
		i = i + 1;
	}
	
	// calculate elemCountRelToBodies from pre-reverse-calculations
	var j;
	for(j = i - 2; j >= 0; j--) {
		elemCountRelToBodies[j] = elemCountRelToBodies[j] + elemCountRelToBodies[j + 1];
	}

	// build position-string out of determined data
	var positionString = numElementsMarked + ";" + i + ";";
	for(j = i - 1; j >= 0; j--) {
		positionString = positionString + names[j] + "," + numSamePrevSibs[j] + "," + numSameNextSibs[j] + "," + elemCountRelToBodies[j] + "," + sameElemCountRelToFathers[j] + "," + sourceIndexRelToBodies[j] + ";";		
	}
	positionString = positionString + ">";
	markedElementsArray[numElementsMarked] = positionString;
	numElementsMarked = numElementsMarked + 1;
	
}

function myDetermineElemCountOfPrevSibsDecendentsOrSelfs(nodeOfInterest) {
	var count = new Array();
	count[0] = 0; // elemCount
	count[1] = 0; // sameElemCount
	var sameName = nodeOfInterest.nodeName.toLowerCase();
	var tmpNode = nodeOfInterest.previousSibling;
	var tempReturn;
	while(tmpNode != null) {
		tempReturn = myDetermineElemCountOfDecendentOrSelf(tmpNode,sameName);
		count[0] = count[0] + tempReturn[0];
		count[1] = count[1] + tempReturn[1];
		tmpNode = tmpNode.previousSibling;
	}
	return count;
}

function myDetermineElemCountOfDecendentOrSelf(rootNode,initNodeName) {
	var nodeCount = new Array();
	nodeCount[0] = 0; // elemCount
	nodeCount[1] = 0; // sameElemCount
	// only count nodes of type elementnode
	if(typeof(rootNode.nodeType) == "undefined") { // Browser doesn't support nodeType-attribute
		if(rootNode.nodeName.substring(0,1).toString() == "#") // not an elementnode
			return nodeCount;
	} else { // The browser supports nodeType-attributes
		if(rootNode.nodeType != 1) // not an elementnode
			return nodeCount;
	}
	// treat rootNode
	nodeCount[0] = 1; // rootNode is in elemCount
	if(rootNode.nodeName.toLowerCase().toString() == initNodeName.toLowerCase().toString())
		nodeCount[1] = 1; // if same named node rootNode is in sameElemCount
	// do recursive calls for childes
	var numChildes = rootNode.childNodes.length;
	var recNodeCount;
	if(numChildes > 0) {
		var k = 0;
		for(k = 0; k < numChildes; k++) {
			recNodeCount = myDetermineElemCountOfDecendentOrSelf(rootNode.childNodes[k],initNodeName);
			nodeCount[0] = nodeCount[0] + recNodeCount[0];
			nodeCount[1] = nodeCount[1] + recNodeCount[1];
		}
	}
	return nodeCount;
}

// On mouse click
function myPermanentlyMarkElement(e) {
  var myE = e || window.event;
  var myTarget = myE.target || myE.srcElement;

  if(typeof(myTarget.isMarkedPermanently) == "undefined" || myTarget.isMarkedPermanently == false) {
    myTarget.myNumElementsMarkedPosition = numElementsMarked;
    storeRecursivePositionList(myTarget);
    myTarget.isMarkedPermanently = true;
  } else if(myTarget.isMarkedPermanently == true) {
    markedElementsArray[myTarget.myNumElementsMarkedPosition] = null;
    myTarget.isMarkedPermanently = false;
  }

}

// On mouse over
function myMarkElementByColorInversion(e) {

  var myE = e || window.event;
  var myTarget = myE.target || myE.srcElement;

  if("p" == myTarget.nodeName.toLowerCase() ||
  		"h" == myTarget.nodeName.toLowerCase().charAt(0) ||
  		"b" == myTarget.nodeName.toLowerCase() ||
  		"code" == myTarget.nodeName.toLowerCase() ||
  		"table" == myTarget.nodeName.toLowerCase() ||
  		"th" == myTarget.nodeName.toLowerCase() ||
  		"tr" == myTarget.nodeName.toLowerCase() ||
  		"td" == myTarget.nodeName.toLowerCase() ||
  		"div" == myTarget.nodeName.toLowerCase() ||
  		"i" == myTarget.nodeName.toLowerCase() ||
  		"span" == myTarget.nodeName.toLowerCase()
  		) {

    if(typeof(myTarget.isMarkedPermanently) == "undefined" || myTarget.isMarkedPermanently == false) {

	  // Determine BackgroundColor and Color of target-element.
	  // If no direct definition in the target-element found a search for an inherited definition is done.
	  // If no inherited definition is found the bodies (default) definitions are used.
      var oldHadBackgroundColor = true;
      var oldHadColor = true;
      if(typeof(myTarget.style.backgroundColor) == "undefined" || myTarget.style.backgroundColor == null || myTarget.style.backgroundColor.length == 0)
        oldHadBackgroundColor = false;
      if(typeof(myTarget.style.color) == "undefined" || myTarget.style.color == null || myTarget.style.color.length == 0)
        oldHadColor = false;

      myTarget.oldbackgroundColor = myTarget.style.backgroundColor;
      myTarget.oldcolor = myTarget.style.color;
      
      
      var mySuperOldBackgroundColor = null;
      var mySuperOldColor = null;
      
      // search for inherited BackgroundColor or Color definition
      if(!(oldHadColor && oldHadBackgroundColor)) {
		 var currentElement = myTarget;
		 while(currentElement != document.body) {
			if(!(typeof(currentElement.style) == "undefined")) {
				if(!(typeof(currentElement.style.backgroundColor) == "undefined"))
					if(currentElement.style.backgroundColor != null)
						if(currentElement.style.backgroundColor.length != 0)
							if(mySuperOldBackgroundColor == null)
								mySuperOldBackgroundColor = currentElement.style.backgroundColor;
				if(!(typeof(currentElement.style.color) == "undefined"))
					if(currentElement.style.color != null)
						if(currentElement.style.color.length != 0)
							if(mySuperOldColor == null)
								mySuperOldColor = currentElement.style.color;
			}
		
			if(mySuperOldColor != null && mySuperOldBackgroundColor != null)
				break;
			currentElement = currentElement.parentNode;
		 }
      }
      
      if(mySuperOldColor == null)
		mySuperOldColor = document.body.text;
	  if(mySuperOldBackgroundColor == null)
	    mySuperOldBackgroundColor = document.body.bgColor;
		
      // inverse background and foreground color
      if(oldHadColor)
        myTarget.style.backgroundColor = myTarget.oldcolor;
      else if(!(typeof(mySuperOldColor) == "undefined") && mySuperOldColor != null && mySuperOldColor.length != 0)
		myTarget.style.backgroundColor = mySuperOldColor;
      else
        myTarget.style.backgroundColor = "#000000";
      if(oldHadBackgroundColor)
        myTarget.style.color = myTarget.oldbackgroundColor;
      else if(!(typeof(mySuperOldBackgroundColor) == "undefined") && mySuperOldBackgroundColor != null && mySuperOldBackgroundColor.length != 0)
        myTarget.style.color = mySuperOldBackgroundColor;
      else
        myTarget.style.color = "#ffffff";
    }
  }
}

// On mouse out
function myReverseMarkElementByColorInversion(e) {
  var myE = e || window.event;
  var myTarget = myE.target || myE.srcElement;

  if(typeof(myTarget.isMarkedPermanently) == "undefined" || myTarget.isMarkedPermanently == false) {
    myTarget.style.backgroundColor = myTarget.oldbackgroundColor;
    myTarget.style.color = myTarget.oldcolor;
  }
}

