using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using log4net;

using WebseitenMonitor.DomainObjects.Behaviour;
using WebseitenMonitor.DomainObjects.DataSource;
using System.IO;
using System.Text;

namespace WebseitenMonitor.User
{
	/// <summary>
	/// Summary description for Test.
	/// </summary>
	public class Test : System.Web.UI.Page
	{	
		private static readonly ILog log = LogManager.GetLogger(typeof(Test));

		protected System.Web.UI.WebControls.Label urlLabel;
		protected System.Web.UI.WebControls.TextBox urlTextBox;
		protected System.Web.UI.WebControls.Label regexLabel;
		protected System.Web.UI.WebControls.TextBox regexTextBox;
		protected System.Web.UI.WebControls.Label messageTemplateLabel;
		protected System.Web.UI.WebControls.TextBox messageTemplateTextBox;
		protected System.Web.UI.WebControls.Button retrieveButton;
		protected System.Web.UI.WebControls.Label urlUserSelectLabel;
		protected System.Web.UI.WebControls.TextBox urlUserSelectTextBox;
		protected System.Web.UI.WebControls.Label selectionPathLabel;
		protected System.Web.UI.WebControls.TextBox selectionPathTextBox;
		protected System.Web.UI.WebControls.Button selectButton;
		protected System.Web.UI.WebControls.Label selectionResultLabel;
		protected System.Web.UI.WebControls.Label resultLabel;
		protected System.Web.UI.WebControls.Label logPageLabel;
		protected System.Web.UI.WebControls.TextBox logPageTextBox;
		protected System.Web.UI.WebControls.Button logButton;

		private void Page_Load(object sender, System.EventArgs e)
		{
			if(!this.IsPostBack) 
			{
				this.urlTextBox.Text = "http://www.ssw.uni-linz.ac.at/Teaching/Lectures/PWG/0405/index.html";
				this.regexTextBox.Text = "<p>(.*?)(?<param1><b>Thema 5:.*?)</p>";
				this.messageTemplateTextBox.Text = "Ergebnis: <br>${param1}";
				this.urlUserSelectTextBox.Text = "http://www.sourceforge.net";
				this.selectionPathTextBox.Text = "0;14;table,b,3,0;tbody,b,0,0;tr,b,0,0;td,b,1,1;table,b,1,0;tbody,b,0,0;tr,b,0,0;td,b,0,1;p,b,0,0;table,b,4,0;tbody,b,0,0;tr,b,2,0;td,b,0,0;p,b,0,1;>";
				this.logPageTextBox.Text = "http://www.ssw.uni-linz.ac.at/Teaching/Lectures/PWG/0405/index.html";
			}
			// Put user code to initialize the page here
		}

		protected void retrieveUserDefinedMessage(object sender, System.EventArgs e) 
		{
			/*
			DataSource ds = new HttpDataSource();
			UserDefinedMessageObservation udb = new UserDefinedMessageObservation();
			string errorMessage = "";
			if(!ds.SetSourceURL(this.urlTextBox.Text,out errorMessage)) 
			{
				resultLabel.Text = errorMessage;
				return;
			}
			TextReader sourceReader;
			DataSource.GetSourceReaderResult getSourceResult = ds.GetSourceReader(out sourceReader, out errorMessage);
			if(getSourceResult != DataSource.GetSourceReaderResult.Ok) 
			{
				resultLabel.Text = errorMessage;
				return;
			}
			if(!udb.SetSearchPattern(this.regexTextBox.Text, out errorMessage)) 
			{
				resultLabel.Text = errorMessage;
				return;
			}
			if(!udb.SetMessageTemplate(this.messageTemplateTextBox.Text, out errorMessage)) 
			{
				resultLabel.Text = errorMessage;
				return;
			}
			String text = sourceReader.ReadToEnd();
			String userDefinedMessage;
			UserDefinedMessageObservation.ApplySearchPatternResult getMsgResult = udb.ApplySearchPattern(text,out userDefinedMessage,out errorMessage);
			if(!getMsgResult.Equals(UserDefinedMessageObservation.ApplySearchPatternResult.Ok)) 
			{
				resultLabel.Text = errorMessage;
				return;
			}
			resultLabel.Text = userDefinedMessage;
			*/
		}

		protected void selectUserSelectedElements(object sender, System.EventArgs e) 
		{
			/*
			DataSource ds = new HttpDataSource();
			UserDefinedMessageObservation udb = new UserDefinedMessageObservation();
			string errorMessage = "";
			if(!ds.SetSourceURL(this.urlUserSelectTextBox.Text,out errorMessage)) 
			{
				selectionResultLabel.Text = errorMessage;
				return;
			}
			bool setSelectedResult = udb.SetSelectedElementsPositionDescriptor(this.selectionPathTextBox.Text, out errorMessage);
			if(!setSelectedResult) 
			{
				selectionResultLabel.Text = errorMessage;
				return;
			}
			TextReader sourceReader;
			DataSource.GetSourceReaderResult getSourceResult = ds.GetSourceReader(out sourceReader, out errorMessage);
			if(getSourceResult != DataSource.GetSourceReaderResult.Ok) 
			{
				selectionResultLabel.Text = errorMessage;
				return;
			}
			String text = sourceReader.ReadToEnd();

			//log.Debug(text);

			IList mySelectedElements = null;
			UserDefinedMessageObservation.GetUserSelectedElementsResult getSelectedResult = udb.GetUserSelectedElements(
				text,
				out mySelectedElements,
				out errorMessage);
			if(getSelectedResult != UserDefinedMessageObservation.GetUserSelectedElementsResult.Match) 
			{
				this.selectionResultLabel.Text = errorMessage;
				return;
			}
			IEnumerator mySelectedEnumerator = mySelectedElements.GetEnumerator();
			StringBuilder tmpStringBuilder = new StringBuilder();
			while(mySelectedEnumerator.MoveNext()) 
			{
				tmpStringBuilder.Append((string)mySelectedEnumerator.Current + "<br>");
			}
			selectionResultLabel.Text = tmpStringBuilder.ToString();
			*/
		}

		protected void logRetrievedWebPage(object sender, System.EventArgs e) 
		{
			DataSource ds = new HttpDataSource();
			string errorMessage = "";
			if(!ds.SetSourceURL(this.logPageTextBox.Text,out errorMessage)) 
			{
				log.Debug("Error during attempt to set SourceUrl: " + errorMessage);
				return;
			}
			bool setEncodingResult = ds.SetSourceEncoding("iso-8859-1", out errorMessage);
			if(!setEncodingResult) 
			{
				log.Debug("Error during attempt to set sourceEncoding: " + errorMessage);
				return;
			}
			TextReader sourceReader;
			DataSource.GetSourceReaderResult getSourceResult = ds.GetSourceReader(out sourceReader, out errorMessage);
			if(getSourceResult != DataSource.GetSourceReaderResult.Ok) 
			{
				log.Debug("Error during attempt to get sourceReader: " + errorMessage);
				return;
			}
			String text = sourceReader.ReadToEnd();

			log.Debug(text);

		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion
	}
}
