using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using WebseitenMonitor.Ui;
using WebseitenMonitor.DataAccess;
using WebseitenMonitor.DomainObjects.Behaviour;

namespace WebseitenMonitor.User
{
	/// <summary>
	/// Summary description for UserDefinedObservationSelectTarget.
	/// </summary>
	public class UserDefinedObservationSelectTarget : System.Web.UI.Page
	{
		private void Page_Load(object sender, System.EventArgs e)
		{
			string selectedElementsPositionDescriptor = Request.Form["selectionPath"];
			if(selectedElementsPositionDescriptor == null) 
			{
				Session["ErrorMessage"] = "Es wurde keine Selektion bermittelt!";
				Response.Redirect("./ErrorPage.aspx");
				return;
			}
			if(Session["NewObservationName"] == null || Session["SelectedPageUrl"] == null 
				|| Session["UserForest"] == null || Session["NewObservationHtmlText"] == null) 
			{
				Session["ErrorMessage"] = "Die Aktion wurde nicht ausreichend parametrisiert!";
				Response.Redirect("./ErrorPage.aspx");
				return;
			}
			// Obtain corresponding UserdefinedMessageObservation object
			string errorMsg;
			UserDefinedMessageObservation udm;
			UserDefinedMessageObservation.CreateUserDefinedMessageObservationResult createRes = UserDefinedMessageObservation.CreateUserDefinedMessageObservation(
				(string)Session["NewObservationName"],
				new Uri((string)Session["SelectedPageUrl"]),
				((int)Session["UserCheckCounter"]),
				null,
				null,
				selectedElementsPositionDescriptor,
				(string)Session["NewObservationHtmlText"],
				UserDefinedMessageObservation.ServerSearchDirection.Left,
				out udm,
				out errorMsg);
			if(createRes == UserDefinedMessageObservation.CreateUserDefinedMessageObservationResult.NoMatch) 
			{
				Session["ErrorMessage"] = "Die bermittelte Selektion konnte serverseitig nicht erfolgreich abgeglichen werden!";
				Response.Redirect("./ErrorPage.aspx");
				return;
			} 
			else if(createRes != UserDefinedMessageObservation.CreateUserDefinedMessageObservationResult.Ok) 
			{
				Session["ErrorMessage"] = "Es ist ein Verarbeitungsfehler aufgetreten!";
				Response.Redirect("./ErrorPage.aspx");
				return;
			}
			// assertion: UserDefinedMessageObservation object successfully obtained
			// Write obtained UserDefinedMessageObservation object to database
			CategoryNavigationForest myForest = (CategoryNavigationForest)Session["UserForest"];
			UserDefinedMessageObservationMediator.WriteResult writeRes = UserDefinedMessageObservationMediator.WriteNewUserDefinedMessageObservation(
				myForest.SelectedCategoryId,
				ref udm,
				out errorMsg);
			Session.Remove("NewObservationHtmlText");
			Session.Remove("NewObservationName");
			Session.Remove("SelectedPageUrl");
			if(writeRes != UserDefinedMessageObservationMediator.WriteResult.Ok) 
			{
				Session["ErrorMessage"] = "Es ist ein Problem whrend dem Datenbankzugriff aufgetreten!";
				Response.Redirect("./ErrorPage.aspx");
			}
			Session["CurrentUserDefinedMessageObservationDetailId"] = udm.Id;
			Response.Redirect("./UserDefinedMessageObservationDetail.aspx");
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.Load += new System.EventHandler(this.Page_Load);
		}
		#endregion
	}
}
